# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS Linux and Scientific Linux as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "sl" || "%{__distinit}" == "sls"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

#TODO: BR: perl(MooseX::AttributeHelpers) when available (actually a deprecated module)
#TODO: BR: perl(Test::Pod::No404s) when available

%global not_tm096 %(perl -MTest::More -e 'print (($Test::More::VERSION < 0.96) ? 1 : 0);' 2>/dev/null || echo 0)
%global not_tm094 %(perl -MTest::More -e 'print (($Test::More::VERSION < 0.94) ? 1 : 0);' 2>/dev/null || echo 0)
%global not_tm088 %(perl -MTest::More -e 'print (($Test::More::VERSION < 0.88) ? 1 : 0);' 2>/dev/null || echo 0)
%global not_tm082 %(perl -MTest::More -e 'print (($Test::More::VERSION < 0.82) ? 1 : 0);' 2>/dev/null || echo 0)

# Select the appropriate system speller
%if 0%{?fedora} > 8 || 0%{?rhel} > 5
%global speller hunspell
%else
%global speller aspell
%endif

Name:		perl-Pod-Coverage-Moose
Version:	0.07
Release:	3.%{__distinit}%{__distvers}
Summary:	Pod::Coverage extension for Moose
License:	GPL+ or Artistic
Group:		Development/Libraries
URL:		http://search.cpan.org/dist/Pod-Coverage-Moose/
Source0:	http://search.cpan.org/CPAN/authors/id/E/ET/ETHER/Pod-Coverage-Moose-%{version}.tar.gz
Patch0:		Pod-Coverage-Moose-0.06-tm096.patch
Patch1:		Pod-Coverage-Moose-0.06-tm094.patch
Patch2:		Pod-Coverage-Moose-0.06-tm088.patch
Patch3:		Pod-Coverage-Moose-0.07-tm082.patch
Patch4:		Pod-Coverage-Moose-0.07-old-mbt.patch
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(id -nu)
BuildArch:	noarch
# Module Build
BuildRequires:	coreutils
BuildRequires:	findutils
BuildRequires:	perl
%if 0%{?fedora} > 20 || 0%{?rhel} > 7
BuildRequires:	perl-generators
%endif
BuildRequires:	perl(Module::Build::Tiny) >= 0.007
# Module Runtime
BuildRequires:	perl(Carp)
BuildRequires:	perl(Class::Load)
BuildRequires:	perl(Moose) >= 0.24
BuildRequires:	perl(namespace::autoclean)
BuildRequires:	perl(Pod::Coverage)
# Test Suite
BuildRequires:	perl(CPAN::Meta)
BuildRequires:	perl(CPAN::Meta::Requirements)
BuildRequires:	perl(ExtUtils::MakeMaker)
BuildRequires:	perl(File::Spec)
BuildRequires:	perl(if)
BuildRequires:	perl(lib)
BuildRequires:	perl(Moose) >= 2.1300
BuildRequires:	perl(Moose::Role)
BuildRequires:	perl(overload)
BuildRequires:	perl(strict)
BuildRequires:	perl(Test::More)
BuildRequires:	perl(Test::Requires)
BuildRequires:	perl(warnings)
# Extra Tests
%if 0%{!?perl_bootstrap:1}
BuildRequires:	perl(blib)
BuildRequires:	perl(IO::Handle)
BuildRequires:	perl(IPC::Open3)
BuildRequires:	perl(Pod::Coverage::TrustPod)
BuildRequires:	perl(Pod::Wordlist)
BuildRequires:	perl(Test::CleanNamespaces) >= 0.15
BuildRequires:	perl(Test::CPAN::Changes)
BuildRequires:	perl(Test::CPAN::Meta)
BuildRequires:	perl(Test::EOL)
BuildRequires:	perl(Test::Kwalitee)
BuildRequires:	perl(Test::MinimumVersion)
BuildRequires:	perl(Test::Mojibake)
BuildRequires:	perl(Test::NoTabs)
BuildRequires:	perl(Test::Pod) >= 1.41
BuildRequires:	perl(Test::Pod::Coverage) >= 1.08
BuildRequires:	perl(Test::Portability::Files)
BuildRequires:	perl(Test::Spelling) >= 0.12, %{speller}-en
# Test module only available from perl 5.10 onwards
%if 0%{?fedora} > 8 || 0%{?rhel} > 5
BuildRequires:	perl(Test::Vars)
%endif
%endif
# Runtime
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))

%description
When using Pod::Coverage in combination with Moose, it will report any
method imported from a Role. This is especially bad when used in
combination with Test::Pod::Coverage, since it takes away its ease of use.

%prep
%setup -q -n Pod-Coverage-Moose-%{version}

# Work around the need for recent versions of Test::More
%if %{not_tm096}
%patch0
%endif
%if %{not_tm094}
%patch1
%endif
%if %{not_tm088}
%patch2
%endif
%if %{not_tm082}
%patch3
%endif

# Don't really need Module::Build::Tiny ≥ 0.034
%patch4

%build
perl Build.PL --installdirs=vendor
./Build

%install
rm -rf %{buildroot}
./Build install --destdir=%{buildroot} --create_packlist=0

%check
./Build test

# Author/Release tests
%if 0%{!?perl_bootstrap:1}
RELEASE_TESTING=1 prove -Ilib $(echo $(find xt/ -name '*.t'))
%endif

%clean
rm -rf %{buildroot}

%files
%if 0%{?_licensedir:1}
%license LICENSE
%else
%doc LICENSE
%endif
%doc Changes CONTRIBUTING README
%{perl_vendorlib}/Pod/
%{_mandir}/man3/Pod::Coverage::Moose.3*

%changelog
* Wed Sep 21 2016 Paul Howarth <paul@city-fan.org> - 0.07-3
- Fix FTBFS when perl is not in the minimal buildroot
- BR: perl-generators where available

* Sat Sep  5 2015 Paul Howarth <paul@city-fan.org> - 0.07-1
- Update to 0.07
  - Fix test failures on Moose ≥ 2.1300 when MooseX::Role::WithOverloading is
    not installed (CPAN RT#106898)
- Require Moose ≥ 2.1300 and drop dependency on MooseX::Role::WithOverloading
- Re-enable Test::Vars with Perl 5.22
- Update patches as needed
- Add patch to support building with old Module::Build::Tiny versions

* Mon Aug 17 2015 Paul Howarth <paul@city-fan.org> - 0.06-1
- Update to 0.06
  - Update some distribution tooling
- Update patches as needed

* Tue Jun 30 2015 Paul Howarth <paul@city-fan.org> - 0.05-4
- Disable use of Test::Vars with Perl 5.22
  (https://github.com/gfx/p5-Test-Vars/issues/11)

* Wed Sep 17 2014 Paul Howarth <paul@city-fan.org> - 0.05-3
- Drop support for building without Test::Requires and Test::CPAN::Changes
- Drop %%defattr, redundant since rpm 4.4
- Use %%license where possible
- BR: perl(MooseX::Role::WithOverloading) for the test suite

* Mon Mar  3 2014 Paul Howarth <paul@city-fan.org> - 0.05-2
- Test::CleanNamespaces now generally available

* Sun Dec 15 2013 Paul Howarth <paul@city-fan.org> - 0.05-1
- Update to 0.05
  - Removed use of Perl6::Junction, which causes warnings with 5.18.0
  - Switch to using namespace::autoclean everywhere
  - Canonical repository migrated to the github moose organization
- Switch to Module::Build::Tiny flow
- This release by ETHER -> update source URL
- Classify buildreqs by usage
- Add a series of patches to support building with old versions of Test::More
- Add patch to support building without Test::Requires

* Thu Jul 25 2013 Paul Howarth <paul@city-fan.org> - 0.04-3
- Don't run the kwalitee test as it fails 'has_better_auto_install'

* Mon Jul 16 2012 Paul Howarth <paul@city-fan.org> - 0.04-2
- BR: perl(Carp), perl(Cwd), perl(File::Path), perl(File::Spec), perl(lib) and
  perl(Moose::Role)

* Tue Mar 13 2012 Paul Howarth <paul@city-fan.org> - 0.04-1
- Update to 0.04
  - Fix the author field in META.yml
  - Compatibility with MooseX::Role::WithOverloading
- Don't need to remove empty directories from the buildroot
- Drop support for distributions prior to FC-3:
  - Don't need to define %%{perl_vendorlib}

* Wed Feb 29 2012 Paul Howarth <paul@city-fan.org> - 0.03-1
- Update to 0.03
  - Add cover_requires option
- This release by MMCLERIC -> update source URL

* Tue Aug 16 2011 Paul Howarth <paul@city-fan.org> - 0.02-7
- Import from Fedora

* Thu Jul 21 2011 Petr Sabata <contyk@redhat.com> - 0.02-6
- Perl mass rebuild

* Tue Jul 19 2011 Petr Sabata <contyk@redhat.com> - 0.02-5
- Perl mass rebuild

* Tue Feb 08 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.02-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Tue Dec 21 2010 Marcela Maslanova <mmaslano@redhat.com> - 0.02-3
- Rebuild to fix problems with vendorarch/lib (#661697)

* Tue May 04 2010 Marcela Maslanova <mmaslano@redhat.com> - 0.02-2
- Mass rebuild with perl-5.12.0

* Tue Mar 16 2010 Jan Klepek 0.02-1
- Specfile autogenerated by cpanspec 1.78
